using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    public partial class T_Sys_Comprehensive
    {
        public T_Sys_Comprehensive()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Sys_Comprehensive");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Comprehensive");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_Comprehensive model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Comprehensive(");
            strSql.Append("F_NewScore,F_NewScoreRemarks,F_NewScoreTime,F_SupervisionScore,F_ScoreSupervision,F_SupervisionTime,F_CreatUser,F_CreatTime,F_Deprid" +
                ",F_Score,F_ScoreRemarks,F_ScoreTime,Information,InformationRemarks" +
                ",InformationTime,Excellent,ExcellentRemarks,ExcellentTime,Immediate,ImmediateRemarks,ImmediateTime)");
            strSql.Append(" values (");
            strSql.Append("@F_NewScore,@F_NewScoreRemarks,@F_NewScoreTime,@F_SupervisionScore,@F_ScoreSupervision,@F_SupervisionTime,@F_CreatUser,@F_CreatTime,@F_Deprid,@F_Score,@F_ScoreRemarks,@F_ScoreTime,@Information,@InformationRemarks" +
                ",@InformationTime,@Excellent,@ExcellentRemarks,@ExcellentTime,@Immediate,@ImmediateRemarks,@ImmediateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NewScore", SqlDbType.Int,4),
                    new SqlParameter("@F_NewScoreRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_NewScoreTime", SqlDbType.DateTime),
                    new SqlParameter("@F_SupervisionScore", SqlDbType.Int,4),
                    new SqlParameter("@F_ScoreSupervision", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_SupervisionTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreatUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreatTime", SqlDbType.DateTime),
                      new SqlParameter("@F_Score", SqlDbType.Int,4),
                    new SqlParameter("@F_ScoreRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_ScoreTime", SqlDbType.DateTime),
                    new SqlParameter("@Information", SqlDbType.Float ,6),
                    new SqlParameter("@InformationRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@InformationTime", SqlDbType.DateTime),
                    new SqlParameter("@Excellent", SqlDbType.Float ,6),
                    new SqlParameter("@ExcellentRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ExcellentTime", SqlDbType.DateTime),
                    new SqlParameter("@Immediate",  SqlDbType.Float ,6),
                    new SqlParameter("@ImmediateRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ImmediateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Deprid", SqlDbType.Int,4)};
            parameters[0].Value = model.F_NewScore;
            parameters[1].Value = model.F_NewScoreRemarks;
            parameters[2].Value = model.F_NewScoreTime;
            parameters[3].Value = model.F_SupervisionScore;
            parameters[4].Value = model.F_ScoreSupervision;
            parameters[5].Value = model.F_SupervisionTime;
            parameters[6].Value = model.F_CreatUser;
            parameters[7].Value = model.F_CreatTime;
            parameters[8].Value = model.F_Score;
            parameters[9].Value = model.F_ScoreRemarks;
            parameters[10].Value = model.F_ScoreTime;
            parameters[11].Value = model.Information;
            parameters[12].Value = model.InformationRemarks;
            parameters[13].Value = model.InformationTime;
            parameters[14].Value = model.Excellent;
            parameters[15].Value = model.ExcellentRemarks;
            parameters[16].Value = model.ExcellentTime;
            parameters[17].Value = model.Immediate;
            parameters[18].Value = model.ImmediateRemarks;
            parameters[19].Value = model.ImmediateTime;
            parameters[20].Value = model.F_Deprid;


            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Comprehensive model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Comprehensive set ");
            strSql.Append("F_NewScore=@F_NewScore,");
            strSql.Append("F_NewScoreRemarks=@F_NewScoreRemarks,");
            strSql.Append("F_NewScoreTime=@F_NewScoreTime,");
            strSql.Append("F_SupervisionScore=@F_SupervisionScore,");
            strSql.Append("F_ScoreSupervision=@F_ScoreSupervision,");
            strSql.Append("F_SupervisionTime=@F_SupervisionTime,");
            strSql.Append("F_CreatUser=@F_CreatUser,");
            strSql.Append("F_CreatTime=@F_CreatTime,");
            strSql.Append("F_Score=@F_Score,");
            strSql.Append("F_ScoreRemarks=@F_ScoreRemarks,");
            strSql.Append("F_ScoreTime=@F_ScoreTime,");
            strSql.Append("Information=@Information,");
            strSql.Append("InformationRemarks=@InformationRemarks,");
            strSql.Append("InformationTime=@InformationTime,");
            strSql.Append("Excellent=@Excellent,");
            strSql.Append("ExcellentRemarks=@ExcellentRemarks,");
            strSql.Append("ExcellentTime=@ExcellentTime,");
            strSql.Append("Immediate=@Immediate,");
            strSql.Append("ImmediateRemarks=@ImmediateRemarks,");
            strSql.Append("ImmediateTime=@ImmediateTime,");
            strSql.Append("F_Deprid=@F_Deprid");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NewScore", SqlDbType.Int,4),
                    new SqlParameter("@F_NewScoreRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_NewScoreTime", SqlDbType.DateTime),
                    new SqlParameter("@F_SupervisionScore", SqlDbType.Int,4),
                    new SqlParameter("@F_ScoreSupervision", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_SupervisionTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreatUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreatTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Score", SqlDbType.Int,4),
                    new SqlParameter("@F_ScoreRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_ScoreTime", SqlDbType.DateTime),
                     new SqlParameter("@Information", SqlDbType.Float ,6),
                    new SqlParameter("@InformationRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@InformationTime", SqlDbType.DateTime),
                     new SqlParameter("@Excellent",  SqlDbType.Float ,6),
                    new SqlParameter("@ExcellentRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ExcellentTime", SqlDbType.DateTime),
                     new SqlParameter("@Immediate",  SqlDbType.Float ,6),
                    new SqlParameter("@ImmediateRemarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ImmediateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Deprid", SqlDbType.Int,4),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_NewScore;
            parameters[1].Value = model.F_NewScoreRemarks;
            parameters[2].Value = model.F_NewScoreTime;
            parameters[3].Value = model.F_SupervisionScore;
            parameters[4].Value = model.F_ScoreSupervision;
            parameters[5].Value = model.F_SupervisionTime;
            parameters[6].Value = model.F_CreatUser;
            parameters[7].Value = model.F_CreatTime;
            parameters[8].Value = model.F_Score;
            parameters[9].Value = model.F_ScoreRemarks;
            parameters[10].Value = model.F_ScoreTime;
            parameters[11].Value = model.Information;
            parameters[12].Value = model.InformationRemarks;
            parameters[13].Value = model.InformationTime;
            parameters[14].Value = model.Excellent;
            parameters[15].Value = model.ExcellentRemarks;
            parameters[16].Value = model.ExcellentTime;
            parameters[17].Value = model.Immediate;
            parameters[18].Value = model.ImmediateRemarks;
            parameters[19].Value = model.ImmediateTime;


            parameters[11].Value = model.F_Deprid;
            parameters[12].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Comprehensive ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Comprehensive ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Comprehensive GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_NewScore,F_NewScoreRemarks,F_NewScoreTime,F_SupervisionScore,F_ScoreSupervision,F_SupervisionTime,F_CreatUser,F_CreatTime,F_Deprid,F_Score,F_ScoreRemarks,F_ScoreTime,Information,InformationRemarks" +
                ",InformationTime,Excellent,ExcellentRemarks,ExcellentTime,Immediate,ImmediateRemarks,ImmediateTime from T_Sys_Comprehensive ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Sys_Comprehensive model = new CallCenterApi.Model.T_Sys_Comprehensive();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Comprehensive DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_Comprehensive model = new CallCenterApi.Model.T_Sys_Comprehensive();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_NewScore"] != null && row["F_NewScore"].ToString() != "")
                {
                    model.F_NewScore = int.Parse(row["F_NewScore"].ToString());
                }
                if (row["F_NewScoreRemarks"] != null)
                {
                    model.F_NewScoreRemarks = row["F_NewScoreRemarks"].ToString();
                }
                if (row["F_NewScoreTime"] != null && row["F_NewScoreTime"].ToString() != "")
                {
                    model.F_NewScoreTime = DateTime.Parse(row["F_NewScoreTime"].ToString());
                }
                if (row["F_SupervisionScore"] != null && row["F_SupervisionScore"].ToString() != "")
                {
                    model.F_SupervisionScore = int.Parse(row["F_SupervisionScore"].ToString());
                }
                if (row["F_ScoreSupervision"] != null)
                {
                    model.F_ScoreSupervision = row["F_ScoreSupervision"].ToString();
                }
                if (row["F_SupervisionTime"] != null && row["F_SupervisionTime"].ToString() != "")
                {
                    model.F_SupervisionTime = DateTime.Parse(row["F_SupervisionTime"].ToString());
                }
                if (row["F_CreatUser"] != null)
                {
                    model.F_CreatUser = row["F_CreatUser"].ToString();
                }
                if (row["F_CreatTime"] != null && row["F_CreatTime"].ToString() != "")
                {
                    model.F_CreatTime = DateTime.Parse(row["F_CreatTime"].ToString());
                }
                if (row["F_Deprid"] != null && row["F_Deprid"].ToString() != "")
                {
                    model.F_Deprid = int.Parse(row["F_Deprid"].ToString());
                }

                if (row["F_Score"] != null && row["F_Score"].ToString() != "")
                {
                    model.F_Score = int.Parse(row["F_Score"].ToString());
                }
                if (row["F_ScoreRemarks"] != null)
                {
                    model.F_ScoreRemarks = row["F_ScoreRemarks"].ToString();
                }
                if (row["F_ScoreTime"] != null && row["F_ScoreTime"].ToString() != "")
                {
                    model.F_ScoreTime = DateTime.Parse(row["F_ScoreTime"].ToString());
                }
                if (row["Immediate"] != null && row["Immediate"].ToString() != "")
                {
                    model.Immediate = float.Parse(row["Immediate"].ToString());
                }
                if (row["ImmediateRemarks"] != null)
                {
                    model.ImmediateRemarks = row["ImmediateRemarks"].ToString();
                }
                if (row["ImmediateTime"] != null && row["ImmediateTime"].ToString() != "")
                {
                    model.ImmediateTime = DateTime.Parse(row["ImmediateTime"].ToString());
                }
                if (row["Information"] != null && row["Information"].ToString() != "")
                {
                    model.Information = float.Parse(row["Information"].ToString());
                }
                if (row["InformationRemarks"] != null)
                {
                    model.InformationRemarks = row["InformationRemarks"].ToString();
                }
                if (row["InformationTime"] != null && row["InformationTime"].ToString() != "")
                {
                    model.InformationTime = DateTime.Parse(row["InformationTime"].ToString());
                }
                if (row["Excellent"] != null && row["Excellent"].ToString() != "")
                {
                    model.Excellent = float .Parse(row["Excellent"].ToString());
                }
                if (row["ExcellentRemarks"] != null)
                {
                    model.ExcellentRemarks = row["ExcellentRemarks"].ToString();
                }
                if (row["ExcellentTime"] != null && row["ExcellentTime"].ToString() != "")
                {
                    model.ExcellentTime = DateTime.Parse(row["ExcellentTime"].ToString());
                }

            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_NewScore,F_NewScoreRemarks,F_NewScoreTime,F_SupervisionScore,F_ScoreSupervision,F_SupervisionTime,F_CreatUser,F_CreatTime,F_Deprid, F_Score,F_ScoreRemarks,F_ScoreTime,Information,InformationRemarks" +
                ",InformationTime,Excellent,ExcellentRemarks,ExcellentTime,Immediate,ImmediateRemarks,ImmediateTime ");
            strSql.Append(" FROM T_Sys_Comprehensive ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_NewScore,F_NewScoreRemarks,F_NewScoreTime,F_SupervisionScore,F_ScoreSupervision,F_SupervisionTime,F_CreatUser,F_CreatTime,F_Deprid, F_Score,F_ScoreRemarks,F_ScoreTime,Information,InformationRemarks" +
                ",InformationTime,Excellent,ExcellentRemarks,ExcellentTime,Immediate,ImmediateRemarks,ImmediateTime ");
            strSql.Append(" FROM T_Sys_Comprehensive ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Comprehensive ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Comprehensive T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_Comprehensive";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
